diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 15f80f785..56f029b0d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -961,400 +871,340 @@ public abstract class Mob extends Entity
     }
 
     @Override
-	public boolean isAlive()
-    {
-        return !removed && getHealth() > 0;
+    public boolean isAlive() {
+        return !this.removed && getHealth() > 0;
     }
 
-    public boolean canBreatheUnderwater()
-    {
+    public boolean canBreatheUnderwater() {
         return false;
     }
 
-    public void onLivingUpdate()
-    {
-        if(newPosRotationIncrements > 0)
-        {
-            double d = x + (newPosX - x) / (double)newPosRotationIncrements;
-            double d1 = y + (newPosY - y) / (double)newPosRotationIncrements;
-            double d2 = z + (newPosZ - z) / (double)newPosRotationIncrements;
+    public void onLivingUpdate() {
+        if (this.newPosRotationIncrements > 0) {
+            double d = this.x + (this.newPosX - this.x) / (double) this.newPosRotationIncrements;
+            double d1 = this.y + (this.newPosY - this.y) / (double) this.newPosRotationIncrements;
+            double d2 = this.z + (this.newPosZ - this.z) / (double) this.newPosRotationIncrements;
             double d3;
-            for(d3 = newRotationYaw - (double) yRot; d3 < -180D; d3 += 360D) { }
-            for(; d3 >= 180D; d3 -= 360D) { }
-            yRot += d3 / (double)newPosRotationIncrements;
-            xRot += (newRotationPitch - (double) xRot) / (double)newPosRotationIncrements;
-            newPosRotationIncrements--;
+            for (d3 = this.newRotationYaw - (double) this.yRot; d3 < -180D; d3 += 360D) {
+            }
+            for (; d3 >= 180D; d3 -= 360D) {
+            }
+            this.yRot += d3 / (double) this.newPosRotationIncrements;
+            this.xRot += (this.newRotationPitch - (double) this.xRot) / (double) this.newPosRotationIncrements;
+            this.newPosRotationIncrements--;
             setPos(d, d1, d2);
-            setRot(yRot, xRot);
-            List<AABB> list1 = world.getCubes(this, bb.getInsetBoundingBox(0.03125D, 0.0D, 0.03125D));
-            if(!list1.isEmpty())
-            {
+            setRot(this.yRot, this.xRot);
+            List<AABBdc> list1 = this.world.getCubes(this, MathHelper.aabbInsetBoundingBox(this.bb, 0.03125D, 0.0D, 0.03125D, new AABBd()));
+            if (!list1.isEmpty()) {
                 double d4 = 0.0D;
-                for(int j = 0; j < list1.size(); j++)
-                {
-                    AABB aabb = list1.get(j);
-                    if(aabb.maxY > d4)
-                    {
-                        d4 = aabb.maxY;
+                for (int j = 0; j < list1.size(); j++) {
+                    AABBdc aabb = list1.get(j);
+                    if (aabb.maxY() > d4) {
+                        d4 = aabb.maxY();
                     }
                 }
 
-                d1 += d4 - bb.minY;
+                d1 += d4 - this.bb.minY;
                 setPos(d, d1, d2);
             }
         }
-        if(isMovementBlocked())
-        {
-            isJumping = false;
-            moveStrafing = 0.0F;
-            moveForward = 0.0F;
-            randomYawVelocity = 0.0F;
-        } else
-        if(!isMultiplayerEntity)
-        {
+        if (isMovementBlocked()) {
+            this.isJumping = false;
+            this.moveStrafing = 0.0F;
+            this.moveForward = 0.0F;
+            this.randomYawVelocity = 0.0F;
+        } else if (!this.isMultiplayerEntity) {
             updateAI();
         }
         boolean inWater = isInWater();
         boolean inLava = isInLava();
-        if(isJumping)
-        {
-            if(inWater)
-            {
-                yd += 0.04D;
-            } else
-            if(inLava)
-            {
-                yd += 0.04D;
-            } else
-            if(onGround)
-            {
+        if (this.isJumping) {
+            if (inWater) {
+                this.yd += 0.04D;
+            } else if (inLava) {
+                this.yd += 0.04D;
+            } else if (this.onGround) {
                 jump();
             }
         }
-        moveStrafing *= 0.98F;
-        moveForward *= 0.98F;
-        randomYawVelocity *= 0.9F;
-        moveEntityWithHeading(moveStrafing, moveForward);
-        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(0.2D, 0.0D, 0.2D));
-        if(list != null && !list.isEmpty())
-        {
-            for(int i = 0; i < list.size(); i++)
-            {
+        this.moveStrafing *= 0.98F;
+        this.moveForward *= 0.98F;
+        this.randomYawVelocity *= 0.9F;
+        moveEntityWithHeading(this.moveStrafing, this.moveForward);
+        List<Entity> list = this.world.getEntitiesWithinAABBExcludingEntity(this, MathHelper.aabbGrow(this.bb, 0.2D, 0.0D, 0.2D, new AABBd()));
+        if (!list.isEmpty()) {
+            for (int i = 0; i < list.size(); i++) {
                 Entity entity = list.get(i);
-                if(entity.isPushable())
-                {
+                if (entity.isPushable()) {
                     entity.push(this);
                 }
             }
-
         }
     }
 
-    protected boolean isMovementBlocked()
-    {
+    protected boolean isMovementBlocked() {
         return getHealth() <= 0;
     }
 
-    protected void jump()
-    {
-    	if(noPhysics) {
-    		return;
-    	}
-        yd = jumpHeight;
-        if (isSprinting())
-        {
-            float f = yRot * 0.01745329F;
-            xd -= MathHelper.sin(f) * 0.2F;
-            zd += MathHelper.cos(f) * 0.2F;
+    protected void jump() {
+        if (this.noPhysics) {
+            return;
+        }
+        this.yd = this.jumpHeight;
+        if (isSprinting()) {
+            float f = this.yRot * 0.01745329F;
+            this.xd -= MathHelper.sin(f) * 0.2F;
+            this.zd += MathHelper.cos(f) * 0.2F;
         }
     }
 
-    protected boolean canDespawn()
-    {
-        return nickname.isEmpty();
+    protected boolean canDespawn() {
+        return this.nickname.isEmpty();
     }
 
-    public void tryToDespawn()
-    {
-        Player entityplayer = world.getClosestPlayerToEntity(this, -1D);
-        if(canDespawn() && entityplayer != null)
-        {
-            double d = entityplayer.x - x;
-            double d1 = entityplayer.y - y;
-            double d2 = entityplayer.z - z;
+    public void tryToDespawn() {
+        Player entityplayer = this.world.getClosestPlayerToEntity(this, -1D);
+        if (canDespawn() && entityplayer != null) {
+            double d = entityplayer.x - this.x;
+            double d1 = entityplayer.y - this.y;
+            double d2 = entityplayer.z - this.z;
             double d3 = d * d + d1 * d1 + d2 * d2;
-            if(d3 > 16384D) // 128 * 128
+            if (d3 > 16384D) // 128 * 128
             {
                 remove();
             }
-            if(entityAge > 600 && random.nextInt(800) == 0)
-            {
-                if(d3 < 1024D)
-                {
-                    entityAge = 0;
-                } else
-                {
+            if (this.entityAge > 600 && this.random.nextInt(800) == 0) {
+                if (d3 < 1024D) {
+                    this.entityAge = 0;
+                } else {
                     remove();
                 }
             }
         }
     }
 
-    protected void updateAI()
-    {
-        entityAge++;
+    protected void updateAI() {
+        this.entityAge++;
         tryToDespawn();
-        moveStrafing = 0.0F;
-        moveForward = 0.0F;
+        this.moveStrafing = 0.0F;
+        this.moveForward = 0.0F;
         float f = 8F;
-        if(random.nextFloat() < 0.02F)
-        {
-            Player entityplayer1 = world.getClosestPlayerToEntity(this, f);
-            if(entityplayer1 != null)
-            {
-                currentTarget = entityplayer1;
-                numTicksToChaseTarget = 10 + random.nextInt(20);
-            } else
-            {
-                randomYawVelocity = (random.nextFloat() - 0.5F) * 20F;
+        if (this.random.nextFloat() < 0.02F) {
+            Player entityplayer1 = this.world.getClosestPlayerToEntity(this, f);
+            if (entityplayer1 != null) {
+                this.currentTarget = entityplayer1;
+                this.numTicksToChaseTarget = 10 + this.random.nextInt(20);
+            } else {
+                this.randomYawVelocity = (this.random.nextFloat() - 0.5F) * 20F;
             }
         }
-        if(currentTarget != null)
-        {
-            lookAt(currentTarget, 10F, getLookingTilt());
-            if(numTicksToChaseTarget-- <= 0 || currentTarget.removed || currentTarget.distanceToSqr(this) > (double)(f * f))
-            {
-                currentTarget = null;
+        if (this.currentTarget != null) {
+            lookAt(this.currentTarget, 10F, getLookingTilt());
+            if (this.numTicksToChaseTarget-- <= 0 || this.currentTarget.removed || this.currentTarget.distanceToSqr(this) > (double) (f * f)) {
+                this.currentTarget = null;
             }
-        } else
-        {
-            if(random.nextFloat() < 0.05F)
-            {
-                randomYawVelocity = (random.nextFloat() - 0.5F) * 20F;
+        } else {
+            if (this.random.nextFloat() < 0.05F) {
+                this.randomYawVelocity = (this.random.nextFloat() - 0.5F) * 20F;
             }
-            yRot += randomYawVelocity;
-            xRot = defaultPitch;
+            this.yRot += this.randomYawVelocity;
+            this.xRot = this.defaultPitch;
         }
         boolean inWater = isInWater();
         boolean inLava = isInLava();
-        if(inWater || inLava)
-        {
-            isJumping = random.nextFloat() < 0.8F;
+        if (inWater || inLava) {
+            this.isJumping = this.random.nextFloat() < 0.8F;
         }
     }
 
-    protected int getLookingTilt()
-    {
+    protected int getLookingTilt() {
         return 40;
     }
 
-    public void lookAt(Entity entity, float yRot, float xRot)
-    {
+    public void lookAt(Entity entity, float yRot, float xRot) {
         double x = entity.x - this.x;
-        double y = entity.z - z;
+        double y = entity.z - this.z;
         double y2;
-        if(entity instanceof Mob)
-        {
-            Mob mob = (Mob)entity;
+        if (entity instanceof Mob mob) {
             y2 = mob.y + mob.getHeadHeight() - (this.y + this.getHeadHeight());
-        } else
-        {
+        } else {
             y2 = (entity.bb.minY + entity.bb.maxY) / 2D - (this.y + (double) getHeadHeight());
         }
         double d3 = MathHelper.sqrt(x * x + y * y);
-        float f2 = (float)((Math.atan2(y, x) * 180D) / Math.PI) - 90F;
-        float f3 = (float)(-((Math.atan2(-y2, d3) * 180D) / Math.PI));
+        float f2 = (float) ((Math.atan2(y, x) * 180D) / Math.PI) - 90F;
+        float f3 = (float) (-((Math.atan2(-y2, d3) * 180D) / Math.PI));
         this.xRot = -rotationLerp(this.xRot, f3, xRot);
         this.yRot = rotationLerp(this.yRot, f2, yRot);
     }
 
-    public boolean hasCurrentTarget()
-    {
-        return currentTarget != null;
+    public boolean hasCurrentTarget() {
+        return this.currentTarget != null;
     }
 
-    public Entity getCurrentTarget()
-    {
-        return currentTarget;
+    public Entity getCurrentTarget() {
+        return this.currentTarget;
     }
 
     private float rotationLerp(float f, float f1, float f2) // Was called rotLerp in the b1.2 leak
     {
         float f3;
-        for(f3 = f1 - f; f3 < -180F; f3 += 360F) { }
-        for(; f3 >= 180F; f3 -= 360F) { }
-        if(f3 > f2)
-        {
+        for (f3 = f1 - f; f3 < -180F; f3 += 360F) {
+        }
+        for (; f3 >= 180F; f3 -= 360F) {
+        }
+        if (f3 > f2) {
             f3 = f2;
         }
-        if(f3 < -f2)
-        {
+        if (f3 < -f2) {
             f3 = -f2;
         }
         return f + f3;
     }
 
-    public void beforeRemove()
-    {
+    public void beforeRemove() {
     }
 
-    public boolean canSpawnHere()
-    {
-        int blockX = MathHelper.floor(x);
-        int blockY = MathHelper.floor(bb.minY);
-        int blockZ = MathHelper.floor(z);
-        if(Blocks.hasTag(world.getBlockId(blockX, blockY, blockZ), BlockTags.PREVENT_MOB_SPAWNS)) {
-        	return false;
+    public boolean canSpawnHere() {
+        int blockX = MathHelper.floor(this.x);
+        int blockY = MathHelper.floor(this.bb.minY);
+        int blockZ = MathHelper.floor(this.z);
+        if (Blocks.hasTag(this.world.getBlockId(blockX, blockY, blockZ), BlockTags.PREVENT_MOB_SPAWNS)) {
+            return false;
         }
-        return world.checkIfAABBIsClear(bb) && world.getCubes(this, bb).size() == 0 && !world.getIsAnyLiquid(bb);
+        return this.world.checkIfAABBIsClear(this.bb) && this.world.getCubes(this, this.bb).isEmpty() && !this.world.getIsAnyLiquid(this.bb);
     }
 
     @Override
-	public void outOfWorld()
-    {
+    public void outOfWorld() {
         hurt(null, 4, null);
     }
 
-    public float getSwingProgress(float partialTick)
-    {
-        float f1 = swingProgress - prevSwingProgress;
-        if(f1 < 0.0F)
-        {
+    public float getSwingProgress(float partialTick) {
+        float f1 = this.swingProgress - this.prevSwingProgress;
+        if (f1 < 0.0F) {
             f1++;
         }
-        return prevSwingProgress + f1 * partialTick;
+        return this.prevSwingProgress + f1 * partialTick;
     }
 
-    public Vec3 getPosition(float partialTick, boolean headOffset)
-    {
-        if(partialTick == 1.0F || isRemoved())
-        {
-            return Vec3.fromPool(x, y + (headOffset ? getHeadHeight() : 0), z);
-        } else
-        {
-            double x = MathHelper.lerp(xo, this.x, partialTick);
-            double y = MathHelper.lerp(yo, this.y, partialTick);
-            double z = MathHelper.lerp(zo, this.z, partialTick);
-            return Vec3.fromPool(x, y + (headOffset ? getHeadHeight() : 0), z);
+    public @NotNull Vector3dc getPosition(float partialTick, boolean headOffset) {
+        if (partialTick == 1.0F || isRemoved()) {
+            return new Vector3d(this.x, this.y + (headOffset ? getHeadHeight() : 0), this.z);
+        } else {
+            double x = MathHelper.lerp(this.xo, this.x, partialTick);
+            double y = MathHelper.lerp(this.yo, this.y, partialTick);
+            double z = MathHelper.lerp(this.zo, this.z, partialTick);
+            return new Vector3d(x, y + (headOffset ? getHeadHeight() : 0), z);
         }
     }
 
     @Override
-	public Vec3 getViewVector(float partialTick)
-    {
-        if(partialTick == 1.0F || isRemoved())
-        {
-            float z = MathHelper.cos(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
-            float x = MathHelper.sin(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
-            float xzLen = -MathHelper.cos(-xRot * (MathHelper.PI / 180f));
-            float y = MathHelper.sin(-xRot * (MathHelper.PI / 180f));
-            return Vec3.fromPool(x * xzLen, y, z * xzLen);
-        }
-        else
-        {
-            float pitch = xRotO + (xRot - xRotO) * partialTick;
-            float yaw = yRotO + (yRot - yRotO) * partialTick;
-            float xzLen = -MathHelper.cos(-pitch * (MathHelper.PI / 180f));
-            float x = MathHelper.sin(-yaw * (MathHelper.PI / 180f) - MathHelper.PI);
-            float y = MathHelper.sin(-pitch * (MathHelper.PI / 180f));
-            float z = MathHelper.cos(-yaw * (MathHelper.PI / 180f) - MathHelper.PI);
-            return Vec3.fromPool(x * xzLen, y, z * xzLen);
+    public @Nullable Vector3dc getViewVector(float partialTick) {
+        if (partialTick == 1.0F || isRemoved()) {
+            float pitch = org.joml.Math.toRadians(this.xRot);
+            float yaw = org.joml.Math.toRadians(this.yRot);
+            float xzLen = -MathHelper.cos(-pitch);
+            float x = MathHelper.sin(-yaw - MathHelper.PI);
+            float y = MathHelper.sin(-pitch);
+            float z = MathHelper.cos(-yaw - MathHelper.PI);
+            return new Vector3d(x * xzLen, y, z * xzLen);
+        } else {
+            float pitch = org.joml.Math.toRadians(this.xRotO + (this.xRot - this.xRotO) * partialTick);
+            float yaw = org.joml.Math.toRadians(this.yRotO + (this.yRot - this.yRotO) * partialTick);
+            float xzLen = -MathHelper.cos(-pitch);
+            float x = MathHelper.sin(-yaw - MathHelper.PI);
+            float y = MathHelper.sin(-pitch);
+            float z = MathHelper.cos(-yaw - MathHelper.PI);
+            return new Vector3d(x * xzLen, y, z * xzLen);
         }
     }
 
 
-    public @Nullable HitResult rayCast(double distance, float partialTick, boolean collideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes)
-    {
-        Vec3 head = getPosition(partialTick, true);
-        Vec3 viewDirection = getViewVector(partialTick);
-        Vec3 furthestPoint = head.add(viewDirection.x * distance, viewDirection.y * distance, viewDirection.z * distance);
-        return world.checkBlockCollisionBetweenPoints(head, furthestPoint, collideWithFluids, ignoreNonColliderBlocks, useSelectorBoxes);
+    public @Nullable HitResult rayCast(double distance, float partialTick, boolean collideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes) {
+        Vector3dc head = getPosition(partialTick, true);
+        Vector3dc viewDirection = getViewVector(partialTick);
+        assert viewDirection != null;
+        Vector3dc furthestPoint = head.add(viewDirection.x() * distance, viewDirection.y() * distance, viewDirection.z() * distance, new Vector3d());
+        return this.world.checkBlockCollisionBetweenPoints(head, furthestPoint, collideWithFluids, ignoreNonColliderBlocks, useSelectorBoxes);
     }
 
-    public int getMaxSpawnedInChunk()
-    {
+    public int getMaxSpawnedInChunk() {
         return 4;
     }
 
     @Override
-	public void handleEntityEvent(byte byte0, float attackedAtYaw)
-    {
-        if(byte0 == 2)
-        {
-            walkAnimSpeed = 1.5F;
-            heartsFlashTime = heartsHalvesLife;
-            hurtTime = maxHurtTime = 10;
+    public void handleEntityEvent(byte byte0, float attackedAtYaw) {
+        if (byte0 == 2) {
+            this.walkAnimSpeed = 1.5F;
+            this.heartsFlashTime = this.heartsHalvesLife;
+            this.hurtTime = this.maxHurtTime = 10;
             this.attackedAtYaw = attackedAtYaw;
             hurt(null, 0, null);
-        } else
-        if(byte0 == 3)
-        {
+        } else if (byte0 == 3) {
             setHealthRaw(0);
             onDeath(null);
-        } else
-        {
+        } else {
             super.handleEntityEvent(byte0, attackedAtYaw);
         }
     }
 
-    public boolean isPlayerSleeping()
-    {
+    public boolean isPlayerSleeping() {
         return false;
     }
 
-    
+
     public @NotNull Direction getHorizontalPlacementDirection(Side side) {
-    	return getHorizontalPlacementDirection(side, PlacementMode.FACING);
+        return getHorizontalPlacementDirection(side, PlacementMode.FACING);
     }
-    
+
     public @NotNull Direction getHorizontalPlacementDirection(Side side, PlacementMode mode) {
-    	if(this.rotationLockHorizontal != null && this.rotationLockHorizontal != Direction.NONE) {
-    		return rotationLockHorizontal;
-    	}
-    	if(this.placementModeOverride != PlacementMode.DEFAULT) {
-    		mode = this.placementModeOverride;
-    	}
-    	if(mode == PlacementMode.SIDE && side != null && side.isHorizontal()) {
-    		return side.getDirection().getOpposite();
-    	}
-    	return Direction.getHorizontalDirection(this);
-    }
-    
+        if (this.rotationLockHorizontal != null && this.rotationLockHorizontal != Direction.NONE) {
+            return this.rotationLockHorizontal;
+        }
+        if (this.placementModeOverride != PlacementMode.DEFAULT) {
+            mode = this.placementModeOverride;
+        }
+        if (mode == PlacementMode.SIDE && side != null && side.isHorizontal()) {
+            return side.getDirection().getOpposite();
+        }
+        return Direction.getHorizontalDirection(this);
+    }
+
     public @NotNull Direction getPlacementDirection(final @NotNull Side side) {
-    	return getPlacementDirection(side, PlacementMode.FACING);
+        return getPlacementDirection(side, PlacementMode.FACING);
     }
-    
+
     public @NotNull Direction getPlacementDirection(final @Nullable Side side, @NotNull PlacementMode mode) {
-    	if(this.rotationLock != null && this.rotationLock != Direction.NONE) {
-    		return rotationLock;
-    	}
-    	if(this.placementModeOverride != PlacementMode.DEFAULT) {
-    		mode = this.placementModeOverride;
-    	}
-    	if(mode == PlacementMode.SIDE && side != null) {
-    		return side.getDirection();
-    	}
-    	return Direction.getDirection(this);
-    }
-    
+        if (this.rotationLock != null && this.rotationLock != Direction.NONE) {
+            return this.rotationLock;
+        }
+        if (this.placementModeOverride != PlacementMode.DEFAULT) {
+            mode = this.placementModeOverride;
+        }
+        if (mode == PlacementMode.SIDE && side != null) {
+            return side.getDirection();
+        }
+        return Direction.getDirection(this);
+    }
+
     public Direction getVerticalPlacementDirection(Side side, double sideHeight) {
-    	return getVerticalPlacementDirection(side, sideHeight, PlacementMode.SIDE);
+        return getVerticalPlacementDirection(side, sideHeight, PlacementMode.SIDE);
     }
-    
+
     public Direction getVerticalPlacementDirection(Side side, double sideHeight, PlacementMode mode) {
-    	if(this.rotationLockVertical != null && this.rotationLockVertical != Direction.NONE) {
-    		return this.rotationLockVertical;
-    	}
-    	if(this.placementModeOverride != PlacementMode.DEFAULT) {
-    		mode = this.placementModeOverride;
-    	}
-    	if(mode == PlacementMode.SIDE) {
-    		if(side.isVertical()) {
-    			return side.getDirection().getOpposite();
-    		}else {
-    			return sideHeight > 0.5 ? Direction.UP : Direction.DOWN;
-    		}
-    	}
-    	return xRot < 0.0f ? Direction.UP : Direction.DOWN;
+        if (this.rotationLockVertical != null && this.rotationLockVertical != Direction.NONE) {
+            return this.rotationLockVertical;
+        }
+        if (this.placementModeOverride != PlacementMode.DEFAULT) {
+            mode = this.placementModeOverride;
+        }
+        if (mode == PlacementMode.SIDE) {
+            if (side.isVertical()) {
+                return side.getDirection().getOpposite();
+            } else {
+                return sideHeight > 0.5 ? Direction.UP : Direction.DOWN;
+            }
+        }
+        return this.xRot < 0.0f ? Direction.UP : Direction.DOWN;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/MobAge.java b/game/core/src/main/java/net/minecraft/core/entity/MobAge.java
index 831606235..3027d248c 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/MobAge.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobAge.java
@@ -2,10 +2,11 @@ package net.minecraft.core.entity;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.Global;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class MobAge
 {
@@ -21,7 +22,7 @@ public class MobAge
 
     private final @NotNull Mob mob;
     private final int maxAge;
-    private @Nullable AABB boundingBox = null;
+    private @Nullable AABBd boundingBox = null;
 
     private int ageDays;
     private long ticksInDay = 0;
@@ -56,12 +57,12 @@ public class MobAge
 
     public void tick(final @NotNull World world) {
 
-        if (this.boundingBox == null) {
-            final @Nullable AABB mobBB = this.mob.getBb();
-            if (mobBB != null) {
-                this.boundingBox = mobBB.copyPermanent();
-            }
-        }
+//        if (this.boundingBox == null) {
+//            final @Nullable AABBdc mobBB = this.mob.getCollisionAABB();
+//            if (mobBB != null) {
+//                this.boundingBox = new AABBd(mobBB);
+//            }
+//        }
         if (isAtMaxAge()) {
             return;
         }
@@ -83,18 +84,19 @@ public class MobAge
             this.ticksInDay -= Global.DAY_LENGTH_TICKS;
         }
 
-        // Update mob attributes
-        if (currentAge < this.maxAge && this.boundingBox != null) {
-            // Update mob size
-            final float size = getAgeScale();
-
-            this.mob.getBb().minX = this.boundingBox.minX * size;
-            this.mob.getBb().minY = this.boundingBox.minY * size;
-            this.mob.getBb().minZ = this.boundingBox.minZ * size;
-            this.mob.getBb().maxX = this.boundingBox.maxX * size;
-            this.mob.getBb().maxY = this.boundingBox.maxY * size;
-            this.mob.getBb().maxZ = this.boundingBox.maxZ * size;
-        }
+        // TODO this is insane and wrong, and before didn't even run
+//        // Update mob attributes
+//        if (currentAge < this.maxAge && this.boundingBox != null) {
+//            // Update mob size
+//            final float size = getAgeScale();
+//
+//            this.mob.getCollisionAABB().minX = this.boundingBox.minX * size;
+//            this.mob.getCollisionAABB().minY = this.boundingBox.minY * size;
+//            this.mob.getCollisionAABB().minZ = this.boundingBox.minZ * size;
+//            this.mob.getCollisionAABB().maxX = this.boundingBox.maxX * size;
+//            this.mob.getCollisionAABB().maxY = this.boundingBox.maxY * size;
+//            this.mob.getCollisionAABB().maxZ = this.boundingBox.maxZ * size;
+//        }
     }
 
     public void writeTag(final @NotNull CompoundTag mobTag) {
